<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>SS Zip Manual and Test</title>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
</head>
<body> 
<h1>phpZIP PRO Manual </h1> 
This test file will show you how to use SS_ZIP class to work with ZIP archives.<br>
<h3>Table of contents:</h3>
<ul>
  <li><strong>Home site:</strong> <a href="http://smiledsoft.com/demos/phpzip/">http://smiledsoft.com/demos/phpzip/</a></li>
  <li><a href="ss_zip_class/index.html" target="_blank">Class description</a> </li>
  <li><a href="#require">Requirements</a></li>
  <li><a href="#Creating">Creating new archive</a></li>
  <li><a href="#addsomefile">Adding files from your file system</a></li>
  <li><a href="#somedata">Adding data from variables</a></li>
  <li><a href="#save">Saving the archive</a></li>
  <li><a href="#Opentheexisting">Opening an existing ZIP archive</a></li>
  <li><a href="#Append">Append another archive</a> </li>
  <li><a href="#Read">Reading entries</a></li>
  <li><a href="#Extractingdatatothevariable">Extracting data to variable</a></li>
  <li><a href="#Extractingdatatodisc">Extracting data to file system</a> </li>
  <li><a href="#Remove">Removing entries</a></li>
</ul>
<h3><a name="require"></a>Requirements</h3>
Actually the only thing you need is zlib, which comes with modern PHP versions by default.<br> 
  So lets begin:<br> 
  test.php: <br> 
  <code><font color="#000000"><font color="#0000BB">&lt;?PHP <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;set_time_limit</font><font color="#007700">(</font><font color="#0000BB">3000</font><font color="#007700">); </font><font color="#FF8000">//for big archives <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#007700">require(</font><font color="#DD0000">"../ss_zip.class.php"</font><font color="#007700">); </font></font></code> 
  <?PHP
	set_time_limit(3000); //for big archives
	require("../ss_zip.class.php");
?> 
  <br> 
  <br> 
  <a name="Creating"></a><h3>Creating new archive:</h3> 
  <code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">// new empty archive with compression level 6 <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$zip</font><font color="#007700">= new </font><font color="#0000BB">ss_zip</font><font color="#007700">(</font><font color="#DD0000">''</font><font color="#007700">,</font><font color="#0000BB">6</font><font color="#007700">);</font></font></code> 
  <?PHP	
	// new empty archive with compression level 6
	$zip= new ss_zip('',6);
?> 
  <br> 
  <br> 
  <a name="addsomefile"></a><h3>Adding files</h3>Now lets add some file from disc and store into archive preserving its original name and path:<br> 
  <code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">//add file from disc and store to the archive under its own name and path <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">add_file</font><font color="#007700">(</font><font color="#DD0000">'testdata/folder1/file1.html'</font><font color="#007700">);</font></font></code> 
  <?PHP
	//add file from disc and store to the archive under its own name and path
	$zip->add_file('testdata/folder1/file1.html');
?> 
  <br> 
  <br> 
  Lets add some file and store it into the archive under other name and path:<br> 
  <code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">//add file from disc and store to the archive under our/path/ourfile2.html <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">add_file</font><font color="#007700">(</font><font color="#DD0000">'testdata/folder1/file1.html'</font><font color="#007700">,</font><font color="#DD0000">'our/path/ourfile2.html'</font><font color="#007700">); </font></font></code> 
  <?PHP
	//add file from disc and store to the archive under our/path/ourfile2.html
	$zip->add_file('testdata/folder1/file1.html','our/path/ourfile2.html');
?> 
  <br> 
  <br> 
  <a name="somedata"></a><h3>Adding data from  variables</h3>
  Now lets take some data generated by PHP (from a variable) and store it into the archive as a file, with name and path:<br> 
  <code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">//add file generated by the script and store it as testphp/thefile.html <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$myfiledata</font><font color="#007700">=</font><font color="#DD0000">"This content was generated by PHP script and stored to ZIP as a file"</font><font color="#007700">; <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">add_data</font><font color="#007700">(</font><font color="#DD0000">'testphp/thefile.html'</font><font color="#007700">, </font><font color="#0000BB">$myfiledata</font><font color="#007700">); </font></font></code> 
  <?PHP	
	//add file generated by the script and store it as testphp/thefile.html
	$myfiledata="This content was generated by PHP script and stored to ZIP as a file";
	$zip->add_data('testphp/thefile.html', $myfiledata);
?> 
  <br> 
  <br> 
  <a name="save"></a><h3>Saving the archive</h3>Lets save the archive to the disk:<br> 
  <code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">//Saving the archive to server under name 'myzip1.zip' <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">save</font><font color="#007700">(</font><font color="#DD0000">'myzip1.zip'</font><font color="#007700">);</font></font></code> 
  <?PHP	
	//Saving the archive to server under name 'myzip1.zip'
	$zip->save('myzip1.zip');
?> 
  <br> 
  Here it is: <a href='myzip1.zip'>myzip1.zip</a> <br> 
  <br> 
  <a name="Opentheexisting"></a>
  <h3>Opening existing ZIP archive</h3>
  Lets open the existing archive (for example this one just saved):<br> 
  <code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">//open an existing archive <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">open</font><font color="#007700">(</font><font color="#DD0000">'myzip1.zip'</font><font color="#007700">);</font></font></code> 
  <?PHP
	//open an existing archive
	$zip->open('myzip1.zip');
?> 
  <br> 
  <br> 
  <a name="Append"></a><h3>Appending another ZIP archive</h3>Append another archive (<a href="append.zip">append.zip</a>):<br> 
  <code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">//append another archive <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">open</font><font color="#007700">(</font><font color="#DD0000">'append.zip'</font><font color="#007700">, </font><font color="#0000BB">true</font><font color="#007700">); </font></font></code> 
  <?PHP
	//append another archive
	$zip->open('append.zip', true);
?> 
  <br> 
  <br> 
  <a name="Read"></a><h3>Reading the entries</h3>
  Read what is in the combined archive:<br> 
  <code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">//read what is in the zip <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#007700">while(</font><font color="#0000BB">$entry</font><font color="#007700">=</font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">read</font><font color="#007700">()){ <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo </font><font color="#DD0000">"Read Entry: &lt;br&gt;"</font><font color="#007700">; <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo </font><font color="#DD0000">'entry index $entry["idx"]=&gt;'</font><font color="#007700">.</font><font color="#0000BB">$entry</font><font color="#007700">[</font><font color="#DD0000">'idx'</font><font color="#007700">].</font><font color="#DD0000">"&lt;br&gt;"</font><font color="#007700">; <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo </font><font color="#DD0000">'entry path $entry["name"]=&gt;'</font><font color="#007700">.</font><font color="#0000BB">$entry</font><font color="#007700">[</font><font color="#DD0000">'name'</font><font color="#007700">].</font><font color="#DD0000">"&lt;br&gt;"</font><font color="#007700">; <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo </font><font color="#DD0000">'entry integer file attribute $entry["attr"]=&gt;'</font><font color="#007700">.</font><font color="#0000BB">$entry</font><font color="#007700">[</font><font color="#DD0000">'attr'</font><font color="#007700">].</font><font color="#DD0000">"&lt;br&gt;"</font><font color="#007700">; <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;echo </font><font color="#DD0000">'entry string file attribute $entry["attrstr"]=&gt;'</font><font color="#007700">.</font><font color="#0000BB">$entry</font><font color="#007700">[</font><font color="#DD0000">'attrstr'</font><font color="#007700">].</font><font color="#DD0000">"&lt;br&gt;&lt;br&gt;"</font><font color="#007700">; <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;}</font></font></code><br> 
  <br> 
  Results:</h2>
<hr size="1" noshade> 
<?PHP
	//read what is in the zip
	while($entry=$zip->read()){
		echo "Read Entry: <br>
		";
		echo 'entry index $entry["idx"]=>'.$entry['idx']."<br>";
		echo 'entry path $entry["name"]=>'.$entry['name']."<br>";
		echo 'entry integer file attribute $entry["attr"]=>'.$entry['attr']."<br>";
		echo 'entry string file attribute $entry["attrstr"]=>'.$entry['attrstr']."<br><br>";
	}
?> 
<hr size="1" noshade> 
<br> 
And save the combined archive as &quot;joined.zip&quot;:<br> 
<code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">//save new archive as joined.zip <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">save</font><font color="#007700">(</font><font color="#DD0000">'joined.zip'</font><font color="#007700">); </font></font></code> 
<?PHP	
	//save new archive as joined.zip
	$zip->save('joined.zip');
?> 
<br> 
Here it is: <a href="joined.zip">joined.zip</a> <br> 
<br> 
<a name="Extractingdatatothevariable"></a><h3>Extracting data to the variable</h3>
<code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">//extracting data to variable <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$mydata </font><font color="#007700">= </font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">extract_data</font><font color="#007700">(</font><font color="#0000BB">1</font><font color="#007700">); <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;echo </font><font color="#DD0000">"This is data extracted from archive, from entry with index 1:&lt;xmp&gt;"</font><font color="#007700">; <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">print_r</font><font color="#007700">(</font><font color="#0000BB">$mydata</font><font color="#007700">); <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;echo </font><font color="#DD0000">"&lt;/xmp&gt;"</font><font color="#007700">;</font></font></code> <br> 
<br> 
Results:
<hr size="1" noshade> 
<?PHP
	//extracting data to the variable
	$mydata = $zip->extract_data(1);
	echo "This is data extracted from archive, from entry with index 1:<xmp>";
	print_r($mydata);
	echo "</xmp>";
?> 
<hr size="1" noshade> 
<br> 
<a name="Extractingdatatodisc"></a><h3>Extracting data to disc</h3> Lets extract some files into 'unpackfolder':<br> 
<code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">//extracting data to disc <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$mydata</font><font color="#007700">=</font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">extract_file</font><font color="#007700">(</font><font color="#0000BB">1</font><font color="#007700">,</font><font color="#DD0000">'unpackfolder'</font><font color="#007700">); <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;echo </font><font color="#DD0000">"This is data extracted from archive, from entry with index 1:&lt;xmp&gt;"</font><font color="#007700">; <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">print_r</font><font color="#007700">(</font><font color="#0000BB">$mydata</font><font color="#007700">); <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;echo </font><font color="#DD0000">"&lt;/xmp&gt; and saved here:&lt;br&gt;"</font><font color="#007700">; <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$path</font><font color="#007700">=</font><font color="#DD0000">'unpackfolder/'</font><font color="#007700">.</font><font color="#0000BB">$mydata</font><font color="#007700">[</font><font color="#DD0000">'file'</font><font color="#007700">]; <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;echo </font><font color="#DD0000">" &lt;a href='$path'target='_blank'&gt;$path&lt;/a&gt; &lt;br&gt;"</font><font color="#007700">; <br /> 
</font></font></code><br> 
Results:
<hr size="1" noshade> 
<?PHP	
	//extracting data to disc
	$mydata=$zip->extract_file(1,'unpackfolder');
	echo "This is data extracted from archive, from entry with index 1:<xmp>";
	print_r($mydata);
	echo "</xmp> and saved here:<br>
	";
	$path='unpackfolder/'.$mydata['file'];
	echo " <a href='$path'target='_blank'>$path</a> <br>";
?> 
<hr size="1" noshade> 
<br> 
<a name="Remove"></a><h3>Removing entries</h3>Now knowing that entry with ID:1 is file "our/path/ourfile2.html" lets remove it and save the archive as 'rem.zip':<br> 
<code><font color="#000000"><font color="#007700">&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#FF8000">//removing entries <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">remove</font><font color="#007700">(</font><font color="#0000BB">1</font><font color="#007700">); <br /> 
&nbsp;&nbsp;&nbsp;&nbsp;</font><font color="#0000BB">$zip</font><font color="#007700">-&gt;</font><font color="#0000BB">save</font><font color="#007700">(</font><font color="#DD0000">'rem.zip'</font><font color="#007700">);</font></font></code> 
<?PHP
	//removing entries
	$zip->remove(1);
	$zip->save('rem.zip');
?> 
<br> 
Here it is: <a href="rem.zip">rem.zip </a> 
</body>
</html>
